﻿'This file is part of No Screen Saver or XScrSave, a utility to temporarily prevent powersaving and screensaver features from activating.
'Copyright (C) 2008 Nathan Tuggy <mailto:nathan@tuggycomputer.com>
'
'This program is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program.  If not, see <http://www.gnu.org/licenses/>.

Public Module nsPowerSaveOptions
    Private Const SPI_SETSCREENSAVEACTIVE As Short = 17
    Private Const SPI_GETSCREENSAVEACTIVE As Short = 16
    Private Const nsHeightForm As Short = 480
    Private Const MsgBoxType As Double = MsgBoxStyle.Question + MsgBoxStyle.MsgBoxSetForeground + MsgBoxStyle.YesNo + MsgBoxStyle.SystemModal
    Private Const nsStart As String = "&Start screen saver"
    Private Const nsStop As String = "&Stop screen saver"
    Private Const ES_CONTINUOUS As Integer = -2147483648
    Private Const ES_DISPLAY_REQUIRED As Integer = 2
    Private Const ES_SYSTEM_REQUIRED As Integer = 1
    Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Integer, ByVal uParam As Boolean, ByRef lpvParam As Object, ByVal fuWinIni As Integer) As Integer
    Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Integer, ByVal uParam As Integer, ByRef lpvParam As Integer, ByVal fuWinIni As Integer) As Integer
    Private Declare Function SetThreadExecutionState Lib "kernel32" (ByRef esFlags As Integer) As Integer

    Private tesThreadState As Integer = ES_CONTINUOUS

    Public Property SystemRequisitioned() As Boolean
        Set(ByVal value As Boolean)
            If value Then
                tesThreadState = tesThreadState Or ES_SYSTEM_REQUIRED
                SetThreadExecutionState(tesThreadState)
            Else
                tesThreadState = tesThreadState And Not ES_SYSTEM_REQUIRED
                SetThreadExecutionState(tesThreadState)
            End If
        End Set
        Get
            Return tesThreadState And ES_SYSTEM_REQUIRED = ES_SYSTEM_REQUIRED
        End Get
    End Property

    Public Property DisplayRequisitioned() As Boolean
        Set(ByVal value As Boolean)
            If value Then
                tesThreadState = tesThreadState Or ES_DISPLAY_REQUIRED
                SetThreadExecutionState(tesThreadState)
            Else
                tesThreadState = tesThreadState And Not ES_DISPLAY_REQUIRED
                SetThreadExecutionState(tesThreadState)
            End If
        End Set
        Get
            Return tesThreadState And ES_DISPLAY_REQUIRED = ES_DISPLAY_REQUIRED
        End Get
    End Property

    Public Property ScreenSaver() As Boolean
        Get
            Dim fActive As Integer
            If Not SystemParametersInfo(SPI_GETSCREENSAVEACTIVE, 0, fActive, 0) Then
                Debug.Print(Err.LastDllError)
            End If
            Return fActive
        End Get
        Set(ByVal value As Boolean)
            SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, value, Nothing, 0)
        End Set
    End Property
End Module
